#@+leo
#@+node:0::@file sayzme.py
#@+body
## Copyright Adam Bunter. 2002.
##
## All Rights Reserved
##
## Permission to use, copy, modify, and distribute this software and its documentation
## for any purpose and without fee is hereby granted, provided that the above copyright
## notice appears in all copies and that both that copyright notice and this permission
## notice appear in supporting documentation, and that the name of Adam Bunter
## not be used in advertising or publicity pertaining to distribution of the
## software without specific, written prior permission.
##
## ADAM BUNTER DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
## INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
## LIVING LOGIC AG OR THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
## DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
## IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR
## IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.


#@<<imports>>
#@+node:1::<<imports>>
#@+body
import sys
import os
from Tkinter import *
root = Tk()
import tkMessageBox
import tkFileDialog
import tkFont

#from win32com.client import constants
import win32com.client
import win32clipboard
import win32con,re
from win32gui import *
import win32api
import cPickle
import string
import pythoncom
#from win32com.client import gencache
#from win32com.client import *
import time
from random import *
import tkColorChooser
import urllib
import htmllib
import formatter

# The following 3 lines may need tweaking for the particular server
# Candidates are pythoncom.Missing and pythoncom.Empty
defaultNamedOptArg=pythoncom.Missing
defaultNamedNotOptArg=pythoncom.Missing
defaultUnnamedArg=pythoncom.Missing

#gencache.EnsureModule('{EEE78583-FE22-11D0-8BEF-0060081841DE}', 0, 1, 0)


#@-body
#@-node:1::<<imports>>


#@<<sapi4>>
#@+node:2::<<sapi4>>
#@+body
class Sapi4:

    voice_list = []

    def __init__(self):
        #init
        self.SpeedPercent=StringVar()
        self.PitchPercent=StringVar()
        self.VolumeLeftPercent=StringVar()
        self.VolumeRightPercent=StringVar()
        
        try:
            self.directss = win32com.client.DispatchWithEvents("{EEE78591-FE22-11D0-8BEF-0060081841DE}", Sapi4Events)
            voice_no = self.directss.Find(0)
            #print 'Woohoo: have found engine'  
            self.voice = self.directss.Select(voice_no)			
            voice_name = self.directss.ModeName(voice_no)
            self.sapi_compliant = 1
            if len(self.voice_list) < 1:
                self.getVoiceList()
            self.selectVoice(voice_name)
        except:			
            log = Log()
            msg = 'Sapi4:__init__ \nError: unable to initialise speech!'
            log.put(msg)			
        return None

    def selectVoice(self, voice_name=''):
        #select voice
        voice_index = 0
        voice_no = 0
        found = 0
        for voice_compare in self.voice_list:
            voice_no = voice_no + 1						
            if voice_compare == voice_name:
                found = 1
                break	
        if found == 0:
            voice_no = 1
        self.directss.AudioReset() 		
        
        try:
            self.directss.Select(voice_no)		
            self.sapi_compliant = 1
        except:	
            self.sapi_compliant = 0
            
        self.directss.Speak(' ')	#don't understand why we need this here but voice doesn't change otherwise          
        self.voice_no = voice_no
        self.voice_index = voice_no - 1
        self.voice_name = self.directss.ModeName(voice_no)	
        #print 'Selected voice: ' + self.voice_name      
        
        self.MinSpeed = self.directss.MinSpeed
        self.MaxSpeed = self.directss.MaxSpeed
        self.Speed = self.directss.Speed	
        if self.MinSpeed > self.MaxSpeed: self.sapi_compliant = 0
        #print 'Speed: from ' + str(self.MinSpeed) + ' to ' + str(self.MaxSpeed) + ' - current ' + str(self.Speed) 
        
        self.MinPitch = self.directss.MinPitch
        self.MaxPitch = self.directss.MaxPitch
        self.Pitch = self.directss.Pitch
        if self.MinPitch > self.MaxPitch: self.sapi_compliant = 0
        #print 'Pitch: from ' + str(self.MinPitch) + ' to ' + str(self.MaxPitch) + ' - current ' + str(self.Pitch)

        self.MinVolumeLeft = self.directss.MinVolumeLeft
        self.MaxVolumeLeft = self.directss.MaxVolumeLeft
        self.VolumeLeft = self.directss.VolumeLeft
        if self.MinVolumeLeft > self.MaxVolumeLeft: self.sapi_compliant = 0
        #print 'VolumeLeft: from ' + str(self.MinVolumeLeft) + ' to ' + str(self.MaxVolumeLeft) + ' - current ' + str(self.VolumeLeft)
        
        self.MinVolumeRight = self.directss.MinVolumeRight
        self.MaxVolumeRight = self.directss.MaxVolumeRight	
        self.VolumeRight = self.directss.VolumeRight
        if self.MinVolumeRight > self.MinVolumeRight: self.sapi_compliant = 0		
        #print 'VolumeRight: from ' + str(self.MinVolumeRight) + ' to ' + str(self.MaxVolumeRight) + ' - current ' + str(self.VolumeRight)
        #print 

        return voice_no

    def getVoiceList(self):
        #fill list of avaliable voices
        voice_count = self.directss.CountEngines
        voice_no = 1
        self.voice_list=[]
        while voice_no < voice_count + 1:
            voice_name = self.directss.ModeName(voice_no)
            #print 'adding voice' + voice_name
            self.voice_list.append(voice_name)
            voice_no = voice_no + 1	
        return None

    def setSpeed(self, speed):
        #set voice speed
        try:
            self.directss.Speed = int(speed)
            speed_percent = str(((self.directss.Speed - self.directss.MinSpeed)*100)  / (self.directss.MaxSpeed-self.directss.MinSpeed)) + '%'
            self.SpeedPercent.set(speed_percent) 	
        except:
            log = Log()
            msg = 'Sapi4:setSpeed \nError: unable to set speed'
            log.put(msg)			
        return None  
    
    def setPitch(self, pitch):
        #set voice pitch
        try:
            self.directss.Pitch = int(pitch)
            pitch_percent = str(((self.directss.Pitch - self.directss.MinPitch)*100)  / (self.directss.MaxPitch-self.directss.MinPitch)) + '%'
            self.PitchPercent.set(pitch_percent)
        except:
            log = Log()
            msg = 'Sapi4:setPitch \nError: unable to set pitch'
            log.put(msg)				
        return None

    def setVolumeLeft(self, volume):
        #set voice volume left
        try:
            self.directss.VolumeLeft = int(volume)
            volume_percent = str(((self.directss.VolumeLeft - self.directss.MinVolumeLeft)*100)  / \
            (self.directss.MaxVolumeLeft-self.directss.MinVolumeLeft)) + '%'
            self.VolumeLeftPercent.set(volume_percent)
            self.setVolumeRight(volume) #change right volume to match left
        except:
            log = Log()
            msg = 'Sapi4:setVolumeLeft \nError: unable to set volume left'
            log.put(msg)				
        return None        

    def setVolumeRight(self, volume):
        #set voice volume right - this seems to have no effect - left volume appears to 
        #control both left and right channels for the engines tested with
        try:
            self.directss.VolumeRight = int(volume)
            volume_percent = str(((self.directss.VolumeRight - self.directss.MinVolumeRight)*100)  / \
            (self.directss.MaxVolumeRight-self.directss.MinVolumeRight)) + '%'
            self.VolumeRightPercent.set(volume_percent)
        except:
            log = Log()
            msg = 'Sapi4:setVolumeRight \nError: unable to set volume right'
            log.put(msg)				
        return None 
        
class Sapi4Events:

    def OnAudioStart(self, hi=defaultNamedNotOptArg, lo=defaultNamedNotOptArg):
        # method AudioStart
        global gwordpositionjumpto		
        global gspeaking
        global gwords
        global gwordposition
        global gcharposition     	
        global ghide	
        global gpaused            
        gspeaking = int(1)        
        if gpaused == 0:   
            gwordposition = int(0)                        
            gcharposition = int(0)            
            ghide = 1
        if gwordpositionjumpto > 0:
            wordposition = 0
            while wordposition < (gwordpositionjumpto -1):
                gcharposition = gcharposition + len(gwords[wordposition]) + 1
                wordposition = wordposition + 1
            gwordposition = gwordpositionjumpto
            gwordpositionjumpto = 0
    
    def OnWordPosition(self, hi=defaultNamedNotOptArg, lo=defaultNamedNotOptArg, byteoffset=defaultNamedNotOptArg):
        # method WordPosition
        global gwords
        global gwordposition
        global gcharposition
        gwordposition = gwordposition + 1
        word = gwords[gwordposition-1]
        #print word + ' ' + str(gwordposition) 
        gcharposition = gcharposition + len(word) + 1

    def OnAudioStop(self, hi=defaultNamedNotOptArg, lo=defaultNamedNotOptArg):
        #method AudioStop
        global gspeaking
        gspeaking = int(0)
#@-body
#@-node:2::<<sapi4>>


#@<<dialog about>>
#@+node:3::<<dialog about>>
#@+body
class DialogAbout:

    def __init__(self, master):
        dialog = Toplevel()
        self.dialog = dialog
        dialog.transient(master.master)
        dialog.title("About Sayz Me")
        dialog.iconname('sayzme')
        dialog.iconbitmap('sayzme.ico')
        frame_about = Frame(dialog)
        frame_about.pack(side=TOP, fill=BOTH, expand=1)
        self.scrollabout = Scrollbar(frame_about, orient='vertical')
        self.scrollabout.pack (fill=Y, side=RIGHT)
        self.textabout = Text(frame_about, 
        wrap='word',
        background='white',
        width=80,
        yscrollcommand=self.scrollabout.set,
        padx=4, pady=4)
        self.textabout.pack (side=TOP, fill=BOTH, expand=YES, padx = 5, pady = 5)
        self.scrollabout.config(command=self.textabout.yview)

        self.textabout.tag_config('head1', foreground = 'black', font='Arial 12 bold', justify='center')		
        self.textabout.tag_config('head2', foreground = 'black', font='Arial 10', justify='center')		
        self.textabout.tag_config('head3', foreground = 'black', font='Arial 10 bold')
        self.textabout.tag_config('norm', foreground = 'black', font='Arial 10')
        self.textabout.tag_config('hlink', foreground = 'blue', underline=1, font='Arial 10')
        self.textabout.tag_config('point', foreground = 'black', font='Arial 10', lmargin1=10, lmargin2=18)
        self.textabout.tag_bind("hlink", "<Button-1>", self.openHLink)		
        self.textabout.tag_bind('hlink', '<Enter>', self.hand_cursor)
        self.textabout.tag_bind('hlink', '<Leave>', self.normal_cursor)
        
        self.textabout.insert(END,"Sayz Me - Version 0.5\n\n", 'head1')
        self.textabout.insert(END,"(c) Copyright 2002. Adam Bunter. All Rights Reserved. \n\n", 'head2') 
        
        #contact info						
        self.textabout.insert(END, 'Contact Information', 'head3')			
        self.textabout.insert(END, '\n\n', 'norm')						
        self.textabout.insert(END, "Visit the website at ", 'norm')		
        self.textabout.insert(END, 'http://sayzme.sourceforge.net', 'hlink')		
        self.textabout.insert(END, " for the latest updates. ", 'norm')				
        self.textabout.insert(END, '\n\n', 'norm')		
                                     
        #acknowledgements					
        self.textabout.insert(END, 'Acknowledgements', 'head3')			        
        self.textabout.insert(END, '\n\n', 'norm')				
        self.textabout.insert(END, 'OSI - ' , 'norm')	
        self.textabout.insert(END, 'http://www.opensource.org/' , 'hlink')			
        self.textabout.insert(END, '\n' , 'norm')			
        self.textabout.insert(END, 'Sourceforge - ' , 'norm')	
        self.textabout.insert(END, 'http://www.sourceforge.net/' , 'hlink')			
        self.textabout.insert(END, '\n' , 'norm')					
        self.textabout.insert(END, 'Python - ' , 'norm')	
        self.textabout.insert(END, 'http://www.python.org' , 'hlink')			
        self.textabout.insert(END, '\n' , 'norm')	
        self.textabout.insert(END, 'Tkinter - ' , 'norm')	
        self.textabout.insert(END, 'http://www.pythonware.com' , 'hlink')			
        self.textabout.insert(END, '\n' , 'norm')	
        self.textabout.insert(END, 'Python Win32 Extentions - ' , 'norm')	
        self.textabout.insert(END, 'http://starship.python.net/crew/mhammond/' , 'hlink')			
        self.textabout.insert(END, '\n' , 'norm')	
        self.textabout.insert(END, 'Active State - ' , 'norm')	
        self.textabout.insert(END, 'http://www.activestate.com/' , 'hlink')			
        self.textabout.insert(END, '\n' , 'norm')			
        self.textabout.insert(END, 'Leo - ' , 'norm')	
        self.textabout.insert(END, 'http://sourceforge.net/projects/leo/' , 'hlink')			
        self.textabout.insert(END, '\n' , 'norm')			
        self.textabout.insert(END, 'Ghost Installer - ' , 'norm')	
        self.textabout.insert(END, 'http://www.ginstall.com/' , 'hlink')			
        self.textabout.insert(END, '\n\n', 'norm')			
                        
        #license
        self.textabout.insert(END, 'License', 'head3')			
        self.textabout.insert(END, '\n\n', 'norm')		
        info = 'Copyright (c) 2002. Adam Bunter. All rights reserved.\n\n'
        self.textabout.insert(END, info, 'norm')			                
        info = 'Redistribution and use in source and binary forms, ' \
        'with or without modification, are permitted provided that the ' \
        'following conditions are met:\n\n'
        self.textabout.insert(END, info, 'norm')	
        info = '- Redistributions of source code must retain the above copyright notice, ' \
        'this list of conditions and the following disclaimer.\n'
        self.textabout.insert(END, info, 'point')	
        info = '- Redistributions in binary form must reproduce the above copyright notice, ' \
        'this list of conditions and the following disclaimer in the documentation and/or other ' \
        'materials provided with the distribution.\n'
        self.textabout.insert(END, info, 'point')	
        info = '- Neither the name of the Adam Bunter nor the names of its contributors may be ' \
        'used to endorse or promote products derived from this software without ' \
        'specific prior written permission.\n\n'
        self.textabout.insert(END, info, 'point')			

        info = 'THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND ' \
        'CONTRIBUTORS \"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, ' \
        'BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS ' \
        'FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT ' \
        'OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, ' \
        'EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, ' \
        'PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR ' \
        'PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF ' \
        'LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE ' \
        'OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ' \
        'ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.'		
        self.textabout.insert(END, info, 'norm')	
        frame = Frame(dialog)
        frame.pack(side=BOTTOM, fill=X, expand=0)		
        button = Button(frame, text='Close', width=10, foreground='DarkRed', command=dialog.destroy)
        button.pack(side=RIGHT, padx=2, pady=2)
        self.centerMe()
        self.textabout.after(200, self.getStats)

    def getStats(self):
        #sourceforge stats
        ProjectId = 67592
        Stats = SourceForgeStats()
        CurrentStats = Stats.getAllTimeStats(ProjectId)
        if CurrentStats == None:
            self.textabout.insert(END, '\n\n', 'norm')
        else:
            self.textabout.insert(END, '\n\n', 'norm')
            self.textabout.insert(END, 'Source Forge Statistics', 'head3')
            self.textabout.insert(END, '\n\n', 'norm')
            for stat in CurrentStats:
                self.textabout.insert(END, stat[0] + ': ' + stat[1] + '\n', 'norm')
            self.textabout.insert(END, '\n', 'norm')		
        return None
        
    def openHLink(self, event):
        start, end = self.textabout.tag_prevrange("hlink", self.textabout.index("@%s,%s" % (event.x, event.y)))
        link =  self.textabout.get(start, end)
        win32api.ShellExecute(0, None, link, None, None, win32con.SW_SHOW)		 

    def hand_cursor(self, event):
        self.textabout.config(cursor="hand2")
        return None

    def normal_cursor(self, event):
        self.textabout.config(cursor="")
        return None
        
    def centerMe(self):
        #center
        top = self.dialog
        top.update()
        sw = top.winfo_screenwidth()
        sh = top.winfo_screenheight()
        w = top.winfo_width()
        h = top.winfo_height()
        x = (sw - w)/2
        y = (sh - h)/2
        geom = '%dx%d+%d+%d' % (w, h, x, y)
        top.geometry(geom)	
        return None

#@-body
#@-node:3::<<dialog about>>


#@<<dialog help>>
#@+node:4::<<dialog help>>
#@+body
class DialogHelp:

    def __init__(self, master):
        dialog = Toplevel()
        self.master = master
        self.dialog = dialog
        dialog.transient(master.master)
        dialog.title("Sayz Me Help")
        dialog.iconname('sayzme')
        dialog.iconbitmap('sayzme.ico')
        frame_about = Frame(dialog)
        frame_about.pack(side=TOP, fill=BOTH, expand=1)
        self.scrollabout = Scrollbar(frame_about, orient='vertical')
        self.scrollabout.pack (fill=Y, side=RIGHT)
        self.textabout = Text(frame_about, 
        wrap='word',
        background='white',
        width=80,
        yscrollcommand=self.scrollabout.set,
        padx=4, pady=4)
        self.textabout.pack (side=TOP, fill=BOTH, expand=YES, padx = 5, pady = 5)
        self.scrollabout.config(command=self.textabout.yview)

        self.textabout.tag_config('head1', foreground = 'black', font='Arial 12 bold', justify='center')		
        self.textabout.tag_config('head2', foreground = 'black', font='Arial 10', justify='center')		
        self.textabout.tag_config('head3', foreground = 'black', font='Arial 10 bold')
        self.textabout.tag_config('norm', foreground = 'black', font='Arial 10')
        self.textabout.tag_config('hlink', foreground = 'blue', underline=1, font='Arial 10')
        self.textabout.tag_config('point', foreground = 'black', font='Arial 10', lmargin1=10, lmargin2=18)
        self.textabout.tag_bind("hlink", "<Button-1>", self.openHLink)		
        self.textabout.tag_bind('hlink', '<Enter>', self.hand_cursor)
        self.textabout.tag_bind('hlink', '<Leave>', self.normal_cursor)
        
        self.textabout.insert(END,"Sayz Me - Help\n\n", 'head1')
        #intro
        self.textabout.insert(END, 'Introduction', 'head3')			
        self.textabout.insert(END, '\n\n', 'norm')				
        info = "Sayz Me is a simple text-to-speech application written in Python " \
        "and distributed freely under a BSD style license."
        self.textabout.insert(END, info, 'norm')			
        self.textabout.insert(END, '\n\n', 'norm')		
        #example use
        self.textabout.insert(END, 'Sayz Me Example Use', 'head3')			
        self.textabout.insert(END, '\n\n', 'norm')		
        info = '1. Open any document that contains text (eg favourite web site).\n' \
        '2. Highlight and copy some text.\n' \
        '3. Sayz Me will maximize and begin reading the copied text.\n\n'  \
        'Tip: double-click to jump to a particular word.'
        self.textabout.insert(END, info, 'norm')			
        self.textabout.insert(END, '\n\n', 'norm')		
        
        #controls
        self.textabout.insert(END, 'Controls', 'head3')			
        self.textabout.insert(END, '\n\n', 'norm')		
        info = 'Pause Button - yeah, you guessed it, pauses the speaking of text.\n'
        self.textabout.insert(END, info, 'norm')		
        info = 'Hide Button - hides the application in the system tray (next to the clock).\n'
        self.textabout.insert(END, info, 'norm')			
        info = 'Read Button - reads the text that has been copied or typed into the program.\n'
        self.textabout.insert(END, info, 'norm')			
        info = 'Reset Button - stop reading, clear displayed text and empty the clipboard.\n'
        self.textabout.insert(END, info, 'norm')			
        info = 'Exit Button - uhhu, it exits the program.'
        self.textabout.insert(END, info, 'norm')			
        self.textabout.insert(END, '\n\n', 'norm')				
        
        #menu file
        self.textabout.insert(END, 'Menu >> File', 'head3')					
        self.textabout.insert(END, '\n\n', 'norm')	
        info = 'Open... - open file and read text.\n'
        self.textabout.insert(END, info, 'norm')	
        info = 'Save as Text... - saves the text to a file.\n'
        self.textabout.insert(END, info, 'norm')	
        info = 'Exit - exit program.\n\n'
        self.textabout.insert(END, info, 'norm')	
                        
        #menu options 
        self.textabout.insert(END, 'Menu >> Options', 'head3')			
        self.textabout.insert(END, '\n\n', 'norm')	
        info = 'Say Greeting - turn off the annoying greeting on startup.\n\n'
        self.textabout.insert(END, info, 'norm')											
        info = 'Listen to Clipboard - automatically read any text copied onto the clipboard.\n'
        self.textabout.insert(END, info, 'norm')		
        info = 'Empty Clipboard - empty the clipboard once reading begins.\n\n'
        self.textabout.insert(END, info, 'norm')		
        info = 'Use System Tray - program will hide in system tray (next to clock).\n'
        self.textabout.insert(END, info, 'norm')
        info = 'Minimize after Speaking - minimize after reading is completed.\n'
        self.textabout.insert(END, info, 'norm')		
        info = 'Maximize before Speaking - maximize before reading copied text.\n'
        self.textabout.insert(END, info, 'norm')							
        self.textabout.insert(END, '\n', 'norm')		
        
        #menu options = text settings
        self.textabout.insert(END, 'Menu >> Options >> Text Settings...', 'head3')			
        self.textabout.insert(END, '\n\n', 'norm')	
        info = 'Font List - select the font. \n'
        self.textabout.insert(END, info, 'norm')
        info = 'Font Size - select the font size. \n'
        self.textabout.insert(END, info, 'norm')							
        info = 'Highlight Characters - number of characters highlighted while reading.\n'
        self.textabout.insert(END, info, 'norm')							
        info = 'Highlight Color - the color of the currently spoken text. \n'
        self.textabout.insert(END, info, 'norm')		
        self.textabout.insert(END, '\n', 'norm')	
                
        #menu options = voice settings		
        self.textabout.insert(END, 'Menu >> Options >> Voice Settings...', 'head3')			
        self.textabout.insert(END, '\n\n', 'norm')									
        info = 'Voice List - select voice. \n'
        self.textabout.insert(END, info, 'norm')						
        info = 'Speed - adjust rate at which the voice reads the text.\n'
        self.textabout.insert(END, info, 'norm')				
        info = 'Pitch - adjust tone of the speakers voice.\n'
        self.textabout.insert(END, info, 'norm')				
        info = 'Volume - adjust volume of the speakers voice.\n'
        self.textabout.insert(END, info, 'norm')				
        info = 'Test Text - text to be spoken when test button is pressed.\n'
        self.textabout.insert(END, info, 'norm')					
        self.textabout.insert(END, '\n', 'norm')	
        
        frame = Frame(dialog)
        frame.pack(side=BOTTOM, fill=X, expand=0)		
        button = Button(frame, text='Close', width=10, foreground='DarkRed', command=self.closeMe)
        button.pack(side=RIGHT, padx=2, pady=2)
        self.centerMe()
        #text = self.textabout.get(1.0,'end')
        #master.Reset()
        #master.text.delete('1.0','end')
        #master.text.insert(END, text)
        #master.ReadAgain()
        
    def openHLink(self, event):
        start, end = self.textabout.tag_prevrange("hlink", self.textabout.index("@%s,%s" % (event.x, event.y)))
        link =  self.textabout.get(start, end)
        win32api.ShellExecute(0, None, link, None, None, win32con.SW_SHOW)		 

    def hand_cursor(self, event):
        self.textabout.config(cursor="hand2")
        return None

    def normal_cursor(self, event):
        self.textabout.config(cursor="")
        return None
        
    def centerMe(self):
        #center
        top = self.dialog
        top.update()
        sw = top.winfo_screenwidth()
        sh = top.winfo_screenheight()
        w = top.winfo_width()
        h = top.winfo_height()
        x = (sw - w)/2
        y = (sh - h)/2
        geom = '%dx%d+%d+%d' % (w, h, x, y)
        top.geometry(geom)	
        return None

    def closeMe(self):
        #self.master.Reset()
        self.dialog.destroy()


#@-body
#@-node:4::<<dialog help>>


#@<<dialog engine options>>
#@+node:5::<<dialog engine options>>
#@+body
class EngineOptions:
    def __init__(self, master):
        self.master = master		
        dialog = Toplevel()
        dialog.transient(master.master)		
        self.dialog = dialog
        dialog.iconname('sayzme')
        #dialog.iconbitmap('sayzme.ico')
        dialog.title("Voice Settings")		
        self.sapi = master.sapi
        #self.sapi.directss.Speak('The default voice is ' + self.sapi.voice_name)
        self.frame_dialog = Frame(dialog, height=500)
        self.frame_dialog.pack(side=TOP, expand=NO, fill=BOTH)
        
        #buttons
        frame_button = Frame(dialog)
        frame_button.pack(side=BOTTOM, expand=NO, fill=X)
        button = Button(frame_button, text='Close', command=dialog.destroy, width=10, foreground='DarkRed')
        button.pack(side=RIGHT, padx=2, pady=2)			
        button = Button(frame_button, text='Test', command=self.test, width=10, foreground='DarkBlue')
        button.pack(side=RIGHT, padx=2, pady=2)
                
        frame_left = Frame(self.frame_dialog)
        frame_left.pack(side=TOP, expand=YES, fill=BOTH)
        
        self.label_nosettings = Label(self.frame_dialog, text="No settings avaliable for selected voice", foreground='red')
        
        scrollbar = Scrollbar(frame_left, orient=VERTICAL)
        self.listbox = Listbox(frame_left, yscrollcommand=scrollbar.set, exportselection=0, font="Arial 10")
        scrollbar.config(command=self.listbox.yview)
        scrollbar.pack(side=RIGHT, fill=Y)
        for item in self.sapi.voice_list:
            self.listbox.insert(END, item)
        self.listbox.pack(side=LEFT, padx=2, pady=2, expand=YES, fill=BOTH)
        self.listbox.select_set(self.sapi.voice_index)
        self.listbox.see(self.sapi.voice_index)
        
        #settings frame
        frame_right = Frame(self.frame_dialog)
        frame_right.pack(side=TOP, expand=NO, fill=BOTH)
        
        #speed
        self.label_speed = Label(frame_right, text=" Speed:", font="Arial 10") 
        self.label_speed.grid(row=0, col=0, sticky=E, padx=2, pady=1) 
        self.scale_speed = Scale(frame_right, length=300, orient='horizontal', command=self.setSpeed, showvalue=0)
        self.scale_speed.grid(row=0, column=1, sticky=W, padx=2, pady=1)  		
        self.label_speed_percent = Label(frame_right, textvariable=self.sapi.SpeedPercent, width=5)
        self.label_speed_percent.grid(row=0, column=2, sticky=W, padx=2, pady=1)

        #pitch
        self.label_pitch = Label(frame_right, text=" Pitch:", font="Arial 10") 
        self.label_pitch.grid(row=1, column=0, sticky=E, padx=2, pady=1) 
        self.scale_pitch = Scale(frame_right, length=300, orient='horizontal', command=self.setPitch, showvalue=0)
        self.scale_pitch.grid(row=1, column=1, sticky=W, padx=2, pady=1)  		
        self.label_pitch_percent = Label(frame_right, textvariable=self.sapi.PitchPercent, width=5)
        self.label_pitch_percent.grid(row=1, column=2, sticky=W, padx=2, pady=1)

        #volume left
        self.label_volume_left = Label(frame_right, text=" Volume:", font="Arial 10") 
        self.label_volume_left.grid(row=2, column=0, sticky=E, padx=2, pady=1) 
        self.scale_volume_left = Scale(frame_right, length=300, orient='horizontal', command=self.setVolume, showvalue=0)
        self.scale_volume_left.grid(row=2, column=1, sticky=W, padx=2, pady=1)  		
        self.label_volume_left_percent = Label(frame_right, textvariable=self.sapi.VolumeLeftPercent, width=5)
        self.label_volume_left_percent.grid(row=2, column=2, sticky=W, padx=2, pady=1)

        #volume right - does not appear to work
#        label = Label(frame_right, text=" Volume Right:", font="Arial 10") 
#        label.grid(row=3, col=0, sticky=E, padx=2, pady=1) 
#        self.scale_volume_right = Scale(frame_right, length=200, orient='horizontal', command=self.sapi.setVolumeRight, showvalue=0)
#        self.scale_volume_right.grid(row=3, column=1, sticky=W, padx=2, pady=1)  		
#        label = Label(frame_right, textvariable=self.sapi.VolumeRightPercent, width=5)
#        label.grid(row=3, column=2, sticky=W, padx=2, pady=1)

        #test text
        self.test_text = StringVar()
        self.test_text.set('This is a test. This is a test. This is a test.')
        label = Label(frame_right, text=" Test Text:", font="Arial 10")
        label.grid(row=3, column=0, sticky=E, padx=2, pady=1) 
        text = Entry(frame_right, textvariable = self.test_text, font="Arial 10", width=50, exportselection=0)
        text.grid(row=3, column=1, columnspan=2, sticky=W, padx=2, pady=1) 
        #canvas
        #frame_canvas = Frame(self.frame_dialog)
        #frame_canvas.pack(side=TOP, expand=NO, fill=X)
        self.canvas = Canvas(self.frame_dialog, height=120)
        self.canvas.pack(expand=NO, fill=BOTH)
        self.drawFace()
        
        self.canvas.after(1000, self.drawFaceBlink)
        self.listbox.after(500, self.poll)
        self.setVoice(self.listbox.get(self.listbox.curselection()[0]), 0)

        self.centerMe()
        return None
    
    def setVoice(self, voice_name, reset=1):
        #select voice
        if reset == 0:
            speed = self.master.speed.get()
            pitch = self.master.pitch.get()
            volume = self.master.volume.get()
            
        voice_no = self.sapi.selectVoice(voice_name)		
        self.scale_speed.configure(from_=self.sapi.directss.MinSpeed, to=self.sapi.directss.MaxSpeed)          
        self.scale_pitch.configure(from_=self.sapi.directss.MinPitch, to=self.sapi.directss.MaxPitch)             
        self.scale_volume_left.configure(from_=self.sapi.directss.MinVolumeLeft, to=self.sapi.directss.MaxVolumeLeft)          		
        #self.scale_volume_right.configure(from_=self.sapi.directss.MinVolumeRight, to=self.sapi.directss.MaxVolumeRight)
        #self.scale_volume_right.set(self.sapi.VolumeRight)
        #viavoice8 min max volumes are back to front - so hide volume scale
        #viavoice8 also change thier min speed and pitch values to the current values - so hide them too i guess
        self.master.voice.set(voice_name)
        if reset == 1:
            speed = self.sapi.directss.Speed
            pitch = self.sapi.directss.Pitch
            volume = self.sapi.directss.VolumeLeft

        self.setSpeed(speed)
        self.setPitch(pitch)
        self.setVolume(volume)
        
        self.scale_speed.set(speed)      
        self.scale_pitch.set(pitch)
        self.scale_volume_left.set(volume)
        
        #if (self.sapi.directss.MinVolumeLeft > self.sapi.directss.MaxVolumeLeft) or self.sapi.sapi_compliant==0:
        if self.sapi.sapi_compliant==0:
            self.label_speed.grid_forget()
            self.scale_speed.grid_forget()
            self.label_speed_percent.grid_forget()
            self.label_pitch.grid_forget()
            self.scale_pitch.grid_forget()
            self.label_pitch_percent.grid_forget()
            self.label_volume_left.grid_forget()
            self.scale_volume_left.grid_forget()
            self.label_volume_left_percent.grid_forget()
            self.canvas.forget()		
            self.label_nosettings.pack()	
        else:
            self.label_nosettings.forget()			
            self.label_speed.grid(row=0, col=0, sticky=E, padx=2, pady=1)
            self.scale_speed.grid(row=0, column=1, sticky=W, padx=2, pady=1)  
            self.label_speed_percent.grid(row=0, column=2, sticky=W, padx=2, pady=1)
            self.label_pitch.grid(row=1, col=0, sticky=E, padx=2, pady=1) 
            self.scale_pitch.grid(row=1, column=1, sticky=W, padx=2, pady=1)  
            self.label_pitch_percent.grid(row=1, column=2, sticky=W, padx=2, pady=1)
            self.label_volume_left.grid(row=2, col=0, sticky=E, padx=2, pady=1)
            self.scale_volume_left.grid(row=2, column=1, sticky=W, padx=2, pady=1)  
            self.label_volume_left_percent.grid(row=2, column=2, sticky=W, padx=2, pady=1)			
            self.canvas.pack()

        speak_text = 'You have selected the voice of ' + voice_name + '.'
        self.sapi.directss.Speak(speak_text) 
        return None

    def setSpeed(self, speed):
        self.sapi.setSpeed(speed)
        self.master.speed.set(speed)
        self.master.SetOpts()
        return None

    def setPitch(self, pitch):
        self.sapi.setPitch(pitch)
        self.master.pitch.set(pitch)
        self.master.SetOpts()
        return None
    
    def setVolume(self, volume):
        self.sapi.setVolumeLeft(volume)
        self.master.volume.set(volume)
        self.master.SetOpts()
        return None
        
    def poll(self):
        new_voice_name = self.listbox.get(self.listbox.curselection()[0])
        if new_voice_name != self.sapi.voice_name:
            self.setVoice(new_voice_name)
        self.drawFaceMouthTalk()
        self.listbox.after(90, self.poll)
        return None

    def test(self):
        #test
        self.sapi.directss.AudioReset()
        if len(self.test_text.get()) < 1:
            self.test_text = 'This is a test. This is a test. This is a test.'
        self.sapi.directss.Speak(self.test_text.get())	
        return None

    def drawFace(self):
        #draw face
        self.face = self.canvas.create_oval(140, 10, 240, 110, tag='face', fill='yellow', width=3)
        self.eyeL = self.canvas.create_oval(170, 40, 180, 60, tag='eye', fill='black')	
        self.eyeR = self.canvas.create_oval(200, 40, 210, 60, tag='eye', fill='black')	
        self.mouthClosed = self.canvas.create_polygon(150, 60, 190, 100, 230, 60, 190, 100,  
            smooth=1, width=3, outline='Black', fill='Red')	
        #hidden at startup 					
        self.mouthOpen1 = self.canvas.create_polygon(150, 60, 170, 75, 190, 90, 210, 75, 230, 60, 190, 90,  
            splinesteps=20, smooth=1, width=3, outline='Black', fill='Red')	
        self.mouthOpen2 = self.canvas.create_polygon(150, 60, 160, 75, 190, 95, 220, 75, 230, 60, 190, 90,  
            splinesteps=20, smooth=1, width=3, outline='Black', fill='Red')					
        self.mouthOpen3 = self.canvas.create_polygon(150, 60, 170, 75, 190, 95, 210, 75, 230, 60, 190, 90,  
            splinesteps=20, smooth=1, width=3, outline='Black', fill='Red')		
        self.mouthOpen4 = self.canvas.create_polygon(150, 60, 160, 80, 190, 100, 220, 80, 230, 60, 190, 90,  
            splinesteps=20, smooth=1, width=3, outline='Black', fill='Red')					
        self.canvas.lower(self.mouthOpen1)		    
        self.canvas.lower(self.mouthOpen2)		
        self.canvas.lower(self.mouthOpen3)				
        self.canvas.lower(self.mouthOpen4)				
        self.blinkL = self.canvas.create_oval(165, 49, 185, 51, tag='eye', fill='black')
        self.blinkR = self.canvas.create_oval(195, 49, 215, 51, tag='eye', fill='black')		
        self.canvas.lower(self.blinkL)		
        self.canvas.lower(self.blinkR)                        
        return None

    def drawFaceMouthTalk(self):
        #open mouth
        global gspeaking
        if gspeaking == 0:
            self.canvas.lift(self.mouthClosed)
            self.canvas.lower(self.mouthOpen1)		    
            self.canvas.lower(self.mouthOpen2)
            self.canvas.lower(self.mouthOpen3)			
            self.canvas.lower(self.mouthOpen4)					
            return None
        mouthdisplay = randrange(1,5) 
        self.canvas.lower(self.mouthClosed)		    		
        self.canvas.lower(self.mouthOpen1)		    
        self.canvas.lower(self.mouthOpen2)
        self.canvas.lower(self.mouthOpen3)		
        self.canvas.lower(self.mouthOpen4)							
        if mouthdisplay == 1:
            self.canvas.lift(self.mouthOpen1)            
        if mouthdisplay == 2:
            self.canvas.lift(self.mouthOpen2)              
        if mouthdisplay == 3:
            self.canvas.lift(self.mouthOpen3)   
        if mouthdisplay == 4:
            self.canvas.lift(self.mouthOpen4) 			          
        return None
        
    def drawFaceBlink(self):
        #blink
        self.canvas.lift(self.blinkL)
        self.canvas.lift(self.blinkR)
        self.canvas.lower(self.eyeL)
        self.canvas.lower(self.eyeR)		
        self.canvas.after(200, self.drawFaceUnblink)
        return None

    def drawFaceUnblink(self):
        self.canvas.lift(self.eyeL)
        self.canvas.lift(self.eyeR)	
        self.canvas.lower(self.blinkL)
        self.canvas.lower(self.blinkR)		
        blinkat = randrange(1,10) * 1000
        self.canvas.after(blinkat, self.drawFaceBlink)		
        return None
        
    def centerMe(self):
        #center
        top = self.dialog
        top.update()
        sw = top.winfo_screenwidth()
        sh = top.winfo_screenheight()
        w = top.winfo_width()
        h = 470#top.winfo_height()
        x = (sw - w)/2
        y = (sh - h)/2
        geom = '%dx%d+%d+%d' % (w, h, x, y)
        top.geometry(geom)		
        return None
#@-body
#@-node:5::<<dialog engine options>>


#@<<dialog text options>>
#@+node:6::<<dialog text options>>
#@+body
class TextOptions:
    def __init__(self, master):
        self.master = master		
        dialog = Toplevel()
        dialog.transient(master.master)		
        self.dialog = dialog
        dialog.iconname('sayzme')
        #dialog.iconbitmap('sayzme.ico')
        dialog.title("Text Settings")		        
        frame = Frame(dialog)
        frame.pack(side=TOP, expand=YES, fill=BOTH)
        
        #font list
        frame_list = Frame(frame)
        frame_list.pack(side=TOP, expand=YES, fill=BOTH)   
        scrollbar = Scrollbar(frame_list, orient=VERTICAL)
        self.listbox = Listbox(frame_list, yscrollcommand=scrollbar.set, exportselection=0, font="Arial 10")
        scrollbar.config(command=self.listbox.yview)
        scrollbar.pack(side=RIGHT, fill=Y)
        names = tkFont.families()
        names = list(names)
        names.sort()
        index = 0
        for name in names:
            self.listbox.insert("end", name)
            if name == self.master.font_family.get():
                font_index = index 
            index = index + 1
        self.listbox.pack(side=LEFT, padx=2, pady=2, expand=YES, fill=BOTH)
        self.listbox.bind("<Button-1>", self.setFont)
        self.listbox.select_set(font_index)
        self.listbox.see(font_index)
        
        #frame to house other settings
        frame_other = Frame(frame)
        frame_other.pack(side=TOP, expand=NO, fill=X)
        #font size
        self.font_size = StringVar()
        self.font_size.set(self.master.font_size.get())
        label = Label(frame_other, text=" Font Size:", font="Arial 10") 
        label.grid(row=0, col=0, sticky=E, padx=2, pady=1) 
        entry = Entry(frame_other, textvariable=self.font_size, width=3)
        entry.grid(row=0, col=1, sticky=E, padx=2, pady=1) 
        #highlight characters
        self.highlight_trailing = StringVar()
        self.highlight_trailing.set(self.master.highlight_trailing.get())		
        label = Label(frame_other, text=" Highlight Characters:", font="Arial 10") 
        label.grid(row=1, col=0, sticky=E, padx=2, pady=1) 			
        entry = Entry(frame_other, width=3, textvariable=self.highlight_trailing)
        entry.grid(row=1, col=1, sticky=E, padx=2, pady=1)			
        #reading color
        label = Label(frame_other, text=" Highlight Color:", font="Arial 10") 
        label.grid(row=2, col=0, sticky=E, padx=2, pady=1) 		
        self.button_color = Button(frame_other, width=4, height=1, relief='sunken', cursor='hand2', 
        background=self.master.reading_color.get(), font='Arial 2', command=self.setReadingColor)
        self.button_color.grid(row=2, col=1, sticky=E, padx=2, pady=1) 
    
        #buttons
        frame = Frame(dialog)
        frame.pack(side=BOTTOM, expand=NO, fill=X)
        button = Button(frame, text='Close', command=dialog.destroy, width=10, foreground='DarkRed')
        button.pack(side=RIGHT, padx=2, pady=2)			
        self.listbox.after(500, self.poll)
                
        self.centerMe()
                
    def poll(self):
        font_family = self.listbox.get(self.listbox.curselection()[0])
        if font_family != self.master.font_family.get() or \
        self.font_size != self.master.font_size.get():
            self.setFont()		
        if self.highlight_trailing.get() != str(self.master.highlight_trailing.get()):
            self.setHighlightTrailing()
        #if self.reading_color.get() != self.master.reading_color.get():
        #    self.setReadingColor()
        self.listbox.after(100, self.poll)
        return None
                
    def setFont(self, args=None):
        #set font family and size
        try:
            font_family = self.listbox.get(self.listbox.curselection()[0])
            font_size = self.font_size.get()
            if self.isnumeric(font_size) == 1:
                font = (font_family, str(self.font_size.get()))
                self.master.font_family.set(font_family)
                self.master.font_size.set(font_size)
                self.master.text.configure(font=font)
                self.master.SetOpts()   
            else:
                self.font_size.set(12)         				
        except:
            log = Log()
            msg = 'SayzMe:setFont \nError: unable to set font!'
            log.put(msg)		
        return None
        
    def setHighlightTrailing(self):
        try:
            if self.isnumeric(self.highlight_trailing.get()) == 1:
                self.master.highlight_leading.set(3)
                self.master.highlight_trailing.set(int(self.highlight_trailing.get()))
                self.master.SetOpts()
            else:
                self.highlight_trailing.set(10)
        except:
            log = Log()
            msg = 'SayzMe:setHighlightTrailing \nError: unable to set Highlighting!'
            log.put(msg)					
        return None		
        
    def setReadingColor(self):
        try:
            color_rgb = tkColorChooser.askcolor(initialcolor=self.master.reading_color.get(), parent=self.dialog)
            color = color_rgb[1]
            if color==None:
                return None
            self.button_color.configure(background=color)
            self.master.text.tag_config('speaking', foreground = color)
            self.master.reading_color.set(color)
            self.master.SetOpts()
        except:
            log = Log()
            msg = 'SayzMe:setReadingColor \nError: unable to set Reading Color!'
            log.put(msg)				
        return None

        
    #nicked this from newsgroups
    def isnumeric(self, str):
        numericprog = re.compile('^[1-9][0-9]*$')
        return numericprog.match(str) is not None

    def centerMe(self):
        #center
        top = self.dialog
        top.update()
        sw = top.winfo_screenwidth()
        sh = top.winfo_screenheight()
        w = top.winfo_width()
        h = top.winfo_height()
        x = (sw - w)/2
        y = (sh - h)/2
        geom = '%dx%d+%d+%d' % (w, h, x, y)
        top.geometry(geom)	
        return None
#@-body
#@-node:6::<<dialog text options>>


#@<<application>>
#@+node:8::<<application>>
#@+body
class App:
    
	#@<<init>>
	#@+node:1::<<init>>
	#@+body
	def __init__(self, master):
	    
		#@<<frames>>
		#@+node:1::<<frames>>
		#@+body
		#initialise
		self.master = master
		#create frames
		
		frame_button = Frame(master)
		frame_button.pack(side=BOTTOM, fill=X)
		frame_status = Frame(master)
		frame_status.pack(side=BOTTOM, fill=X)
		frame_text = Frame(master)
		frame_text.pack(side=TOP, fill=BOTH, expand=YES)
		
		
		
		#@-body
		#@-node:1::<<frames>>

	    
		#@<<global variables>>
		#@+node:2::<<global variables>>
		#@+body
		#initialise global variables
		global gspeaking
		gspeaking = int(0)
		global ghide
		ghide = int(0)
		global gwordposition
		gwordposition = int(0)
		global gcharposition
		gcharposition = int(0)
		global gpaused
		gpaused = int(0)
		global gwords
		gwords = string.split('Welcome to Sayz Me.')
		global gwordpositionjumpto
		gwordpositionjumpto=int(0)
		global ghidden 
		ghidden = int(0)
		global gexit 
		gexit = int(0)
		global gtrayout
		gtrayout=int(0)
		global gtrayin
		gtrayin=int(0)
		
		#@-body
		#@-node:2::<<global variables>>

	    
		#@<<app variables>>
		#@+node:3::<<app variables>>
		#@+body
		#initialise app variables
		self.wordposition = int(0)
		self.charposition = int(0)
		self.words=string.split('Welcome to Sayz Me.')
		#initialse options and set defaults
		self.font_family = StringVar()
		self.font_family.set('Arial')
		self.font_size = StringVar()
		self.font_size.set('10')
		
		self.paused = IntVar()
		self.paused.set(0)
		self.countposition = StringVar()
		self.countposition.set('')
		self.listen_to_clip = IntVar()
		self.listen_to_clip.set(1)
		self.empty_clip = IntVar()
		self.empty_clip.set(1)
		self.use_system_tray = IntVar()
		self.use_system_tray.set(0)
		self.to_top = IntVar()
		self.to_top.set(1)
		self.min_after_speak = IntVar()
		self.min_after_speak.set(1)
		self.voice = StringVar()
		self.voice.set(0)
		self.speed = IntVar()
		self.speed.set(150)
		self.pitch = IntVar()
		self.pitch.set(140)
		self.volume = IntVar()      
		self.highlight_leading = IntVar()
		self.highlight_leading.set(5)
		self.highlight_trailing = IntVar()
		self.highlight_trailing.set(20)
		self.reading_color = StringVar()
		self.greeting = IntVar()
		self.greeting.set(1)
		# set saved options
		self.GetOpts()  
		self.SetOpts()  
		
		#@-body
		#@-node:3::<<app variables>>

	    
		#@<<start engine>>
		#@+node:4::<<start engine>>
		#@+body
		# initialise speech engine
		self.sapi = Sapi4()
		self.sapi.selectVoice(self.voice.get())
		self.sapi.setSpeed(self.speed.get())
		self.sapi.setPitch(self.pitch.get())
		self.volume.set(self.sapi.directss.VolumeLeft)
		if self.greeting.get()==1:
		    self.sapi.directss.Speak ("Welcome to sayz-me.")
		#@-body
		#@-node:4::<<start engine>>

	    
		#@<<build ui>>
		#@+node:5::<<build ui>>
		#@+body
		#set title and build menu 
		self.master.iconname('sayzme')
		self.master.iconbitmap('sayzme.ico')
		self.master.title("Sayz Me")
		self.build_menu(master)
		
		#count label as status bar
		self.label = Label (frame_status, 
		foreground='black', 
		textvariable=self.countposition, 
		bd=1, 
		relief=SUNKEN, 
		anchor=W, 
		font='Arial 7')
		self.label.pack(side=BOTTOM, fill=X) 
		
		#text widget    
		text_font = (self.font_family.get(), self.font_size.get())    
		self.scroll = Scrollbar(frame_text, orient='vertical')
		self.scroll.pack (fill=Y, side=RIGHT)
		self.text = Text(frame_text, wrap='word', yscrollcommand=self.scroll.set, font=text_font)
		self.text.bind('<Double-1>', self.JumpTo)
		self.text.pack (side=LEFT, fill=BOTH, expand=YES)
		self.scroll.config(command=self.text.yview)
		if self.greeting.get()==1:
		    self.text.insert(END,"Welcome to sayz-me.")
		self.text.tag_config("spoken", foreground = 'grey40')
		self.text.tag_config('speaking', foreground = self.reading_color.get())
		#pause button
		self.checkbutton = Checkbutton(frame_button, 
		text='Pause', 
		foreground='DarkBlue', 
		width = 10, 
		indicatoron=0, 
		variable = self.paused,  
		command= self.AudioPauseResume)
		self.checkbutton.pack (side=LEFT, padx = 2, pady = 5)
		#hide button
		self.button = Button(frame_button, 
		text='Hide', 
		foreground='DarkBlue', 
		width = 10,  
		command= self.doHide)
		self.button.pack (side=LEFT, padx = 2, pady = 5)
		#exit button        
		self.button = Button(frame_button, 
		text='Exit', 
		foreground='DarkRed', 
		activeforeground ='DarkRed', 
		width = 10, 
		command=self.doExit)
		self.button.pack (side=RIGHT, padx = 2, pady = 5)
		#reset button
		self.button = Button(frame_button, 
		text='Reset', 
		foreground='Red', 
		activeforeground ='Red', 
		width = 10, 
		command=self.Reset)
		self.button.pack (side=RIGHT, padx = 2, pady = 5)
		#ReadAgain button
		self.button = Button(frame_button, 
		text='Read', 
		foreground='DarkGreen', 
		activeforeground ='DarkGreen', 
		width = 10, command=self.ReadAgain)
		self.button.pack (side=RIGHT, padx = 2, pady = 5)	
		#fill empty space
		self.label = Label (frame_button, width=4)
		self.label.pack(side=LEFT)
		
		#resize
		self.MaximizeMe()
		
		#system tray thread
		self.systray = SysTray()
		
		#self.master.protocol("WM_DELETE_WINDOW", self.doExit) #window close button
		self.master.protocol("WM_CLOSE", self.doExit)
		
		#timer for display update
		self.id = self.label.after(250, self.timer)
		#@-body
		#@-node:5::<<build ui>>

	
	
	
	#@-body
	#@-node:1::<<init>>

    
	#@<<timer>>
	#@+node:2::<<timer>>
	#@+body
	def timer(self):
	    #get clipboard text or update display
	    #print 'timer'
	    global gspeaking
	    global gpaused
	    global gexit
	    global gtrayout 
	    global gtrayin
	    if gexit ==1:
	        self.master.quit()
	    if gtrayout == 1:
	        gtrayout = 0
	        self.MaximizeMe()
	    if gtrayin == 1:
	        gtrayin=0
	        self.master.withdraw()
	    #time.sleep(0)
	    if gspeaking == 0:
	        if gpaused == 0:
	            self.text.tag_remove('speaking', '0.0', 'end')
	            self.text.tag_remove('spoken', '0.0', 'end')
	            global ghide
	            if ghide==1: self.MinimizeMe()
	            ghide = 0
	        self.WinClip()
	    else:
	        gpaused = 0
	        global gcharposition
	        charspeaking = gcharposition + self.highlight_trailing.get() 
	        charspoken = gcharposition - self.highlight_leading.get()
	        self.text.tag_remove('speaking', '0.0', 'end')
	        self.text.tag_remove('spoken', '0.0', 'end')
	        self.text.tag_add('speaking', '0.0', '0.0 + ' + str(charspeaking) + ' char wordend')
	        self.text.tag_add('spoken', '0.0', '0.0 + ' + str(charspoken) + 'char wordstart')
	        self.text.tag_lower('speaking', 'spoken')
	        self.text.see('0.0 + ' + str(charspeaking) + ' char wordend')
	        countposition = (" Word: " + str(gwordposition) + "  Character: " + str(gcharposition))
	        self.countposition.set(countposition)
	    #self.master.update()
	    self.id = self.label.after(200, self.timer)
	
	
	#@-body
	#@-node:2::<<timer>>

    
	#@<<menus>>
	#@+node:3::<<menus>>
	#@+body
	def OpenHomepage(self):	
	    link =  'http://sayzme.sourceforge.net'
	    win32api.ShellExecute(0, None, link, None, None, win32con.SW_SHOW)		 	
	
	def OpenAbout(self):   
	    about = DialogAbout(self)
	
	def OpenHelp(self):   
	    help = DialogHelp(self)
	
	def OpenEngineOptions(self):
	    self.sapi.directss.AudioReset()
	    self.engineoptions = EngineOptions(self)
	    self.master.wait_window(self.engineoptions.dialog)
	    self.sapi.directss.AudioReset()  
	    return None
	
	def OpenTextOptions(self):
	    self.sapi.directss.AudioReset()
	    textoptions = TextOptions(self)
	    return None	
	    
	def build_menu(self,master):
	    # create menus
	    menu = Menu(master)
	    master.config(menu=menu)
	    
	    menufile = Menu(menu)
	    menu.add_cascade(label="File", menu=menufile)
	    menufile.add_command(label="Open...", command=self.openFile)
	    menufile.add_command(label="Save As Text ...", command=self.saveFile)	
	#    menufile.add_command(label="Save As Wav ...", command=self.saveWav)		
	    menufile.add_separator()
	    menufile.add_command(label="Exit", command=self.doExit)
	    
	    menuoptions = Menu(menu)
	    menu.add_cascade(label="Options", menu=menuoptions)
	    menuoptions.add_checkbutton(label="Say Greeting", variable=self.greeting, command = self.SetOpts)	
	    menuoptions.add_separator()	
	    menuoptions.add_checkbutton(label="Listen to Clipboard", variable=self.listen_to_clip, command = self.SetOpts)
	    menuoptions.add_checkbutton(label="Empty Clipboard", variable=self.empty_clip, command = self.SetOpts)
	    menuoptions.add_separator()
	    menuoptions.add_checkbutton(label="Use System Tray", variable=self.use_system_tray, command = self.SetOpts)
	    menuoptions.add_checkbutton(label="Minimize After Speaking", variable=self.min_after_speak, command = self.SetOpts)
	    menuoptions.add_checkbutton(label="Maximize Before Speaking", variable=self.to_top, command = self.SetOpts)	
	    menuoptions.add_separator()
	    menuoptions.add_command(label="Text Settings...", command = self.OpenTextOptions)		
	    menuoptions.add_command(label="Voice Settings...", command = self.OpenEngineOptions)
	
	    helpmenu = Menu(menu)
	    menu.add_cascade(label="Help", menu=helpmenu)
	    helpmenu.add_command(label="About Sayz Me...", command=self.OpenAbout)
	    helpmenu.add_separator()	
	    helpmenu.add_command(label="Sayz Me Help", command=self.OpenHelp)
	    helpmenu.add_command(label="Sayz Me Homepage", command=self.OpenHomepage)
	#@-body
	#@-node:3::<<menus>>

    
	#@<<min max>>
	#@+node:4::<<min max>>
	#@+body
	def MaximizeMe(self):
	    # maximize
	    master = self.master
	    xoffset = 1
	    yoffset = 1
	    width = master.winfo_screenwidth() - 10
	    height = master.winfo_screenheight() - 80
	    master.update()
	    master.deiconify()
	    master.geometry("%dx%d%+d%+d" % (width, height, xoffset, yoffset))
	    master.update()
	    return None
	
	def MinimizeMe(self):
	    if self.min_after_speak.get() == 1 : 
	        if self.use_system_tray.get()==1:
	            self.master.withdraw()
	        else:
	            self.master.iconify()        
	    return None
	
	
	#@-body
	#@-node:4::<<min max>>

    
	#@<<options>>
	#@+node:5::<<options>>
	#@+body
	def SetOpts(self):
	    try:
	        f=open('options', 'w')
	        opt = {'listen_to_clip': self.listen_to_clip.get(),
	               'empty_clip': self.empty_clip.get(),
	               'to_top': self.to_top.get(),
	               'speed':self.speed.get(),
	               'pitch':self.pitch.get(),
	               'min_after_speak':self.min_after_speak.get(),
	               'highlight_leading':self.highlight_leading.get(),
	               'highlight_trailing':self.highlight_trailing.get(),
	               'reading_color':self.reading_color.get(),
	               'greeting':self.greeting.get(),
	               'voice':self.voice.get(),
	               'font_family':self.font_family.get(),
	               'font_size':self.font_size.get(),
	               'use_system_tray':self.use_system_tray.get()}
	        cPickle.dump(opt, f)
	        f.close
	    except:
	        tkMessageBox.showwarning( "Error", "Unable to save settings!")  
	        f.close
	
	def GetOpts(self):
	    # read saved variables
	    try:
	        f=open('options', 'r')
	        opt = cPickle.load(f)
	        f.read()
	        f.close
	    except IOError:
	        #no file so write defaults
	        f=open('options', 'w')
	        opt = {'listen_to_clip': 1, 'empty_clip': 1, 'to_top': 1, 'speed': 150, 'pitch':160,'min_after_speak':1,
	        'highlight_leading':3, 'highlight_trailing':20, 'reading_color':'Blue', 'greeting':1, 'voice':0, 
	        'font_family':'Arial', 'font_size':'12', 'use_system_tray':0}
	        cPickle.dump(opt, f)
	        f.close
	        
	    except:
	        f.close
	        
	    try:
	        self.listen_to_clip.set(opt['listen_to_clip'])
	        self.empty_clip.set(opt['empty_clip'])
	        self.to_top.set(opt['to_top'])
	        self.speed.set(opt['speed'])
	        self.pitch.set(opt['pitch'])
	        self.min_after_speak.set(opt['min_after_speak'])
	        self.highlight_leading.set(opt['highlight_leading'])
	        self.highlight_trailing.set(opt['highlight_trailing'])
	        self.reading_color.set(opt['reading_color'])		
	        self.greeting.set(opt['greeting'])		
	        self.voice.set(opt['voice'])
	        self.font_family.set(opt['font_family'])
	        self.font_size.set(opt['font_size'])		
	        self.use_system_tray.set(opt['use_system_tray'])		
	        
	    except KeyError:
	        self.SetOpts()		
	
	#@-body
	#@-node:5::<<options>>

    
	#@<<misc>>
	#@+node:6::<<misc>>
	#@+body
	def doHide(self):
	    global gtrayin
	    self.use_system_tray.set(1)
	    gtrayin=1
	
	def doExit(self):
	    DestroyWindow(self.systray.hwnd)            
	    self.master.quit()
	
	def saveWav(self):
	    #save as wave file
	    return None
	    
	def saveFile(self):
	    #save
	    self.sapi.directss.AudioReset()
	    try:
	        text = self.text.get(1.0,'end')
	        file = tkFileDialog.asksaveasfilename(defaultextension=".txt") 
	        if len(file) > 0:
	            f = open(file,"w")
	            f.write(text)
	            f.close()
	    except:
	        pass
	
	def openFile(self):
	    self.sapi.directss.AudioReset()
	    #open file
	    file = tkFileDialog.Open(self.master, filetypes=[('Text files', '*.txt'),('All files', '*')])	
	    filename = file.show()
	    try:
	        f = open(filename,"r")
	        text = f.read()
	        f.close()
	        text = self.FormatClipText(text)
	        global gpaused
	        gpaused = 0
	        global gwords
	        gwords = string.split(text)
	        self.text.delete('1.0','end');
	        self.text.insert(END, text)
	        global gwordposition
	        gwordposition = int(0)
	        global gcharposition
	        gcharposition = int(0)
	        self.sapi.directss.Speak(text)
	    except:
	        #self.sapi.directss.Speak("Error - unable to open file.")
	        pass
	    return None
	
	def Reset(self):
	    # reset
	    win32clipboard.OpenClipboard()
	    win32clipboard.EmptyClipboard()
	    win32clipboard.CloseClipboard()
	    self.sapi.directss.AudioReset()
	    self.text.delete('1.0','end')
	    self.text.insert(END,"Ready.")
	    self.sapi.directss.Speak("Ready.")
	    return None
	
	def ReadAgain(self):
	    self.sapi.directss.AudioReset()
	    self.text.tag_remove('speaking', '0.0', 'end')
	    self.text.tag_remove('spoken', '0.0', 'end')
	    text = self.text.get(1.0,'end')
	    global gwords
	    gwords = string.split(text)	
	    global gwordposition
	    gwordposition = int(0)
	    global gcharposition
	    gcharposition = int(0)	
	    self.sapi.directss.Speak(text)
	    return None
	    
	def SetVoice(self, voice):
	    #apply selected voice and save option
	    voiceindex = 0
	    for voicefind in self.engineoptions.voicelist:
	        voiceindex = voiceindex + 1
	        if voicefind == voice:
	            self.voice.set(voice)
	            self.SetOpts()
	            self.sapi.directss.Select(voiceindex)
	            self.pitch.set(self.sapi.directss.Pitch)
	            self.speed.set(self.sapi.directss.Speed)
	            return None
	    self.voice.set(0)
	    self.SetOpts()
	    self.sapi.directss.Select(0)
	    self.pitch.set(self.sapi.directss.Pitch)
	    self.speed.set(self.sapi.directss.Speed)	
	    return None
	
	def SetVoiceSpeed(self, speed):
	    self.sapi.directss.Speed = self.speed.get()
	    self.SetOpts()
	    return None
	
	def SetVoicePitch(self, pitch):
	    self.sapi.directss.Pitch = self.pitch.get()
	    self.SetOpts()
	    return None
	
	def SetVoiceVolume(self, volume):
	    self.sapi.directss.VolumeLeft = self.volume.get()
	    self.sapi.directss.VolumeRight = self.volume.get()
	    return None
	
	def SetGreeting(self, greeting):
	    self.SetOpts()
	    return None
	    
	def AudioPauseResume(self):
	    #pause audio
	    global gpaused
	    if self.paused.get() == 1:
	        self.sapi.directss.AudioPause()
	        gpaused = 1
	    else:
	        f= self.sapi.directss.AudioResume()
	        gpaused = 1
	    return None
	
	def WinClip(self):
	    #get windows clipboard text
	    if self.listen_to_clip.get() == 1:
	        win32clipboard.OpenClipboard()
	        if win32clipboard.IsClipboardFormatAvailable(win32con.CF_TEXT):
	            clip_text = win32clipboard.GetClipboardData(win32con.CF_TEXT)
	            if self.empty_clip.get() == 1: win32clipboard.EmptyClipboard()
	        else:
	            clip_text =''
	        win32clipboard.CloseClipboard()
	            #parse clipboard text
	        if len(clip_text) > 0:
	            clip_text = self.FormatClipText(clip_text)
	            global gpaused
	            gpaused = 0
	            global gwords
	            gwords = string.split(clip_text)
	            self.text.delete('1.0','end');
	            self.text.insert(END, clip_text)
	            global gwordposition
	            gwordposition = int(0)
	            global gcharposition
	            gcharposition = int(0)
	            if self.to_top.get() == 1: self.MaximizeMe()
	            self.sapi.directss.Speak(clip_text)
	        return None
	
	def FormatClipText(self, clip_text):
	    #format clip text
	    while clip_text.find('\t') > -1:
	        clip_text = clip_text.replace('\t',' ')
	    while clip_text.find('\r') > -1:
	        clip_text = clip_text.replace('\r', '\n')
	    while clip_text.find('\n ') > -1:
	        clip_text = clip_text.replace('\n ','\n')
	    while clip_text.find('  ') >-1:
	        clip_text = clip_text.replace('  ', ' ')
	    while clip_text.find('\n\n\n') > -1:
	        clip_text = clip_text.replace('\n\n\n','\n\n')
	    while clip_text.find('\n\n') >-1:
	        clip_text = clip_text.replace('\n\n','\n--\n')
	    return clip_text
	
	def JumpTo(self, clip_text):
	    #jump to word
	    global gwordpositionjumpto
	    gpaused
	    if gpaused==0:
	        self.sapi.directss.AudioReset()
	        text = self.text.get(1.0,'end')
	        wordindex = self.text.index(CURRENT)
	        speaktext = self.text.get(wordindex + ' wordstart', 'end')
	        spokentext = self.text.get('0.0', wordindex)
	        spokenlist = string.split(spokentext)
	        self.sapi.directss.Speak(speaktext)
	        gwordpositionjumpto = len(spokenlist)
	    return None
	    
	
	def doNothing(self, na=None):
	    return None
	    
	def doTest(self, test_text = 'This is a test.'):
	    #test speakers voice
	    win32clipboard.OpenClipboard()
	    win32clipboard.EmptyClipboard()
	    win32clipboard.CloseClipboard()
	    self.sapi.directss.AudioReset()
	    self.text.delete('1.0','end');
	    self.text.insert(END, test_text)
	    self.sapi.directss.Speak(test_text)
	    return None
	#@-body
	#@-node:6::<<misc>>

	
    

#@-body
#@-node:8::<<application>>


#@<<system tray>>
#@+node:9::<<system tray>>
#@+body
# Creates a task-bar icon.  Run from Python.exe to see the
# messages printed.

class SysTray:
    def __init__(self):
        message_map = {
            win32con.WM_DESTROY: self.OnDestroy,
            win32con.WM_COMMAND: self.OnCommand,
            win32con.WM_USER+20 : self.OnTaskbarNotify,
        }
        # Register the Window class.
        wc = WNDCLASS()
        hinst = wc.hInstance = GetModuleHandle(None)
        wc.lpszClassName = "SayzMeSysTray"
        wc.style = win32con.CS_VREDRAW | win32con.CS_HREDRAW;
        wc.hCursor = LoadCursor( 0, win32con.IDC_ARROW )
        wc.hbrBackground = win32con.COLOR_WINDOW
        wc.lpfnWndProc = message_map # could also specify a wndproc.
        classAtom = RegisterClass(wc)
        # Create the Window.
        style = win32con.WS_OVERLAPPED | win32con.WS_SYSMENU
        self.hwnd = CreateWindow( classAtom, "SayzMe", style, \
                    0, 0, win32con.CW_USEDEFAULT, win32con.CW_USEDEFAULT, \
                    0, 0, hinst, None)
        UpdateWindow(self.hwnd)

        # Try and find a custom icon
        iconPathName = os.path.abspath('sayzme.ico')
        if os.path.isfile(iconPathName):
            icon_flags = win32con.LR_LOADFROMFILE | win32con.LR_DEFAULTSIZE
            hicon = LoadImage(hinst, iconPathName, win32con.IMAGE_ICON, 0, 0, icon_flags)
        else:
            print "Can't find a Python icon file - using default"
            hicon = LoadIcon(0, win32con.IDI_APPLICATION)

        flags = NIF_ICON | NIF_MESSAGE | NIF_TIP
        nid = (self.hwnd, 0, flags, win32con.WM_USER+20, hicon, "Sayz Me")
        Shell_NotifyIcon(NIM_ADD, nid)

    def OnDestroy(self, hwnd, msg, wparam, lparam):
        nid = (self.hwnd, 0)
        Shell_NotifyIcon(NIM_DELETE, nid)
        PostQuitMessage(0) # Terminate the app.
        
    def DoDestroy(self):
        nid = (self.hwnd, 0)
        Shell_NotifyIcon(NIM_DELETE, nid)
        PostQuitMessage(0) # Terminate the app.		
        
    def OnTaskbarNotify(self, hwnd, msg, wparam, lparam):
        if lparam==win32con.WM_LBUTTONUP:
            print 
        elif lparam==win32con.WM_LBUTTONDBLCLK:
            global gtrayout
            gtrayout = 1
        elif lparam==win32con.WM_RBUTTONUP:
            menu = CreatePopupMenu()
            #AppendMenu( menu, win32con.MF_STRING, 1023, "Hide")
            AppendMenu( menu, win32con.MF_STRING, 1024, "Show")
            AppendMenu( menu, win32con.MF_STRING|win32con.MF_SEPARATOR, 0, '')
            #AppendMenu( menu, win32con.MF_STRING, 1026, "Read")
            #AppendMenu( menu, win32con.MF_STRING, 1027, "Stop")	
            #AppendMenu( menu, win32con.MF_STRING|win32con.MF_SEPARATOR, 0, '')														
            #AppendMenu( menu, win32con.MF_STRING, 1027, "Pause")
            #AppendMenu( menu, win32con.MF_STRING, 1028, "Resume")						
            #AppendMenu( menu, win32con.MF_STRING|win32con.MF_SEPARATOR, 0, '')			
            AppendMenu( menu, win32con.MF_STRING, 1025, "Exit" )
            pos = GetCursorPos()
            TrackPopupMenu(menu, win32con.TPM_LEFTALIGN, pos[0], pos[1], 0, self.hwnd, None)
        return 1

    def OnCommand(self, hwnd, msg, wparam, lparam):
        id = LOWORD(wparam)
        if id == 1023:
            global gtrayin
            gtrayin=1
        elif id == 1024:
            global gtrayout
            gtrayout=1
        elif id == 1025:
            global gexit			
            gexit = 1
            DestroyWindow(self.hwnd)
        elif id == 1026:
            global gtrayread
            gtrayread=1
        elif id == 1027:						
            global gtraystop
            gtraystop = 1
        elif id == 1028:						
            global gtraypause
            gtraypause = 1
        elif id == 1029:						
            global gtrayresume
            gtrayresume = 1						
        else:
            print "Unknown command -", id

def main():
    w=MainWindow()
    PumpMessages()
    

#@-body
#@-node:9::<<system tray>>


#@<<sourceforge stats>>
#@+node:7::<<sourceforge stats>>
#@+body
class SourceForgeStats:
    
    def __init__(self):	
        return None
    
    def getAllTimeStats(self, ProjectId):
        #returns list of all time stats from sourceforge
        stats=[]
        page = 'http://sourceforge.net/project/stats/?group_id=' + str(ProjectId)
        StartLine = '<br><p>	<p><b>Statistics for All Time</b></p>'

        #get stats page
        try:
            f = urllib.urlopen(page)
            data = f.read()	
        except IOError:
            return None
        #get just the html table containing stats
        FindText = 'Statistics for All Time'
        EndTable = '</TABLE>'
        PageList=data.splitlines()
        j=0
        TableStartLine = 0
        TableEndLine = 0
        StatTable=''
        for LineText in PageList:
            j=j+1
            if TableStartLine > 0 and TableEndLine == 0:
                StatTable = StatTable + LineText
            if re.search(FindText, LineText):
                TableStartLine = j 
            if (TableStartLine > 0) and re.search(EndTable, LineText):
                TableEndLine = j
                break
        if TableStartLine == 0 or TableEndLine == 0:
            return None
        #put html table contents into list of tuples
        parser=self.TableParser()
        parser.feed(StatTable)
        parser.close()
        StatList =  parser.result 
        StatTypeList = StatList[0]
        StatResultList = StatList[1]
        j=0
        StatOut =''
        StatsOutList=[]
        for StatType in StatTypeList:
            StatsOutList.append((StatType, StatResultList[j],))
            j = j + 1   		
        return StatsOutList
        
    #nicked this table parser from newsgroups
    class TableParser(htmllib.HTMLParser):
        def __init__(self):
            self.active=0
            self.finished=0
            self.skipping=0
            self.result=[]
            self.current_row=[]
            self.current_data=[]
            htmllib.HTMLParser.__init__(
                self, formatter.NullFormatter())
        def start_table(self,attributes):
            if not self.finished:
                self.active=1
        def end_table(self):
            self.active=0
            self.finished=1
        def start_tbody(self,attributes):
            self.skipping=0
        def end_tbody(self):
            self.skipping=1
        def start_thead(self,attributes):
            self.skipping=1
        def end_thead(self):
            self.skipping=0
        def start_tfoot(self,attributes):
            self.skipping=1
        def end_tfoot(self):
            self.skipping=0
        def start_caption(self,attributes):
            self.skipping=1
        def end_caption(self):
            self.skipping=0
        def start_th(self,attributes):
            self.skipping=self.skipping+1
        def end_th(self):
            self.skipping=self.skipping-1
        def start_tr(self,attributes):
            if self.active and not self.skipping:
                self.current_row = []
        def end_tr(self):
            if self.active and not self.skipping:
                self.result.append(self.current_row)
        def start_td(self,attributes):
            if self.active and not self.skipping:
                self.current_data = []
        def end_td(self):
            if self.active and not self.skipping:
                self.current_row.append(
                    string.join(self.current_data))
        def handle_data(self, data):
            if self.active and not self.skipping:
                self.current_data.append(data)
#@-body
#@-node:7::<<sourceforge stats>>


#@<<log>>
#@+node:10::<<log>>
#@+body
class	Log:
    
    def	__init__(self, logfilename='Log.txt'):
        #init
        self.logfilename = logfilename
    
    def put(self, msg='Log test.'):
        #write message to log file
		try:
			self.logfile = open(self.logfilename, 'a')
			ts = time.ctime()
			self.logfile.write('\n\nLogged at ' + str(ts) + ': \n')
			self.logfile.write(str(msg))
			self.logfile.close()
			return 1
		except:
			return 0
#@-body
#@-node:10::<<log>>

if __name__ == "__main__":
    app = App(root)	
    
    root.mainloop()
    

#@-body
#@-node:0::@file sayzme.py
#@-leo
